﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PDF417DecodeCSharpSample
{
    public partial class Form1 : Form
    {
        [DllImport("gdi32.dll")]
        public static extern bool DeleteObject(long hdc);

        string sImageFile = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void btnRecogFile_Click(object sender, EventArgs e)
        {
            string sFileName = null;
            IntPtr pResult;

            if (dlgOpen.ShowDialog() == DialogResult.OK)
            {
                sFileName = dlgOpen.FileName;
                picView.Load(sFileName);
                pResult = DllInterface.PDF417DecodeImageFile(sFileName);

                if (pResult.ToInt32() != 0)
                {
                  AnalyticalData(pResult);
                  DllInterface.PDF417Free(pResult);
                }
                else
                {
                  tbInfo.Clear();
                  tbInfo.Text = "no barcode found";
                }
                btnRecognize.Enabled = false;
            }
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Environment.Exit(0);
        }

        private void btnOpenFile_Click(object sender, EventArgs e)
        {
            if (dlgOpen.ShowDialog() == DialogResult.OK)
            {
                sImageFile = dlgOpen.FileName;
                tbInfo.Clear();
                picView.Load(sImageFile);
                btnRecognize.Enabled = true;
            }
        }

        private void btnRecognize_Click(object sender, EventArgs e)
        {
            Int32 hBitmap = 0;
            IntPtr pResult = default(IntPtr);
            //sImageFile = "c:\\pdf417\\04.png";
            hBitmap = DllInterface.LoadImageEx(sImageFile);
            pResult = DllInterface.PDF417DecodeBitmap(hBitmap);
            DeleteObject(hBitmap);
            if (pResult.ToInt32() != 0)
            {
                AnalyticalData(pResult);
                DllInterface.PDF417Free(pResult);
            }
            else
            {
                tbInfo.Clear();
                tbInfo.Text = "no barcode found";
            }
            btnRecognize.Enabled = false;

        }

        public void AnalyticalData(IntPtr pResult)
        {
            string sTemp = null;
            string sAscll = null;
            string sHex = null;
            string sbyteHex = null;
            DllInterface.Result r = default(DllInterface.Result);
            byte[] bBuf = new byte[8193];
            int nCount = 0;
            string sSpace = null;
            int i = 0;
            nCount = 1;

            object a = Marshal.PtrToStructure(pResult, r.GetType());
            r = (DllInterface.Result)a;

            Marshal.Copy(r.pData, bBuf, 0, r.nSize);
            sTemp = "barcode detected" + "\r\n" + "Position:   ";
            for (i = 0; i <= 3; i++)
            {
                sTemp = sTemp + "(" + r.ptCorner[i].X + "," + r.ptCorner[i].Y + ")  ";
            }
            sTemp = sTemp + "\r\n";
            for (i = 0; i <= r.nSize; i++)
            {
                sbyteHex = Convert.ToString(bBuf[i], 16);
                if ((sbyteHex.Length < 2) & (sbyteHex.Length > 0))
                {
                    sbyteHex = "0" + sbyteHex;
                }
                sHex = sHex + sbyteHex + " ";
                if ((bBuf[i] >= 32) & (bBuf[i] < 127))
                {
                    sAscll = sAscll + Convert.ToChar(bBuf[i]);
                }
                else
                {
                    sAscll = sAscll + ".";
                }
                nCount = nCount + 1;
                if (nCount % 17 == 0)
                {
                    sTemp = sTemp + sHex + "        " + sAscll + "\r\n";
                    nCount = 1;
                    sHex = "";
                    sAscll = "";
                }
            }
            if (nCount != 1)
            {
                for (i = 0; i <= (16 - nCount); i++)
                {
                    sSpace = sSpace + "   ";
                }
                sTemp = sTemp + sHex + sSpace + "        " + sAscll + "\r\n";
            }
            tbInfo.Clear();
            tbInfo.Text = sTemp;
        }
    }

}
